Для получения данных о производительности вашей учетной записи агентства запустите отчет, чтобы инициировать асинхронную операцию для существующего шаблона Report .
В этом руководстве описано, как создать отчет, описывающий эффективность работы вашего агентского аккаунта, используя API Agencies & Brands для запуска шаблона Report .
Прежде чем начать
Прежде чем продолжить, необходимо выполнить следующие действия:
Запустите выполнение отчета.
Для запуска существующего отчета используйте метод agencies.reports.run .
В следующем примере выполняется POST запрос для запуска формирования отчета:
ОТДЫХ
Запрос
curl --request POST \
'https://agenciesandbrands.googleapis.com/v1/agencies/ACCOUNT_ID/reports/123456789:run' \
--header 'Authorization: Bearer ACCESS_TOKEN' \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--data '{}' \
--compressed
Замените следующее:
-
ACCOUNT_ID: ваш идентификатор учетной записи. -
ACCESS_TOKEN: ваш токен доступа.
Ответ
{
"name": "agencies/ACCOUNT_ID/reports/123456789/operations/10486370264",
"done": false,
"metadata": {
"@type": "type.googleapis.com/google.ads.agenciesandbrands.v1.RunReportMetadata"
}
}
Java
/* * Copyright (c) 2026 Google LLC * * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except * in compliance with the License. You may obtain a copy of the License at * * http://www.apache.org/licenses/LICENSE-2.0 * * Unless required by applicable law or agreed to in writing, software distributed under the License * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express * or implied. See the License for the specific language governing permissions and limitations under * the License. */ package com.google.api.services.samples.agenciesandbrands.v1.agencies.reports; import com.google.api.services.agenciesandbrands.v1.AgenciesAndBrands; import com.google.api.services.agenciesandbrands.v1.model.Operation; import com.google.api.services.agenciesandbrands.v1.model.RunReportRequest; import com.google.api.services.samples.agenciesandbrands.v1.Utils; import java.io.IOException; import java.security.GeneralSecurityException; import net.sourceforge.argparse4j.ArgumentParsers; import net.sourceforge.argparse4j.inf.ArgumentParser; import net.sourceforge.argparse4j.inf.ArgumentParserException; import net.sourceforge.argparse4j.inf.Namespace; public class RunReport { /** * Executes the run operation for a report. * * @param agenciesAndBrandsClient the initialized Agencies & Brands API client. * @param accountId the account ID of the agency that created the report. * @param reportId the resource ID of the report to run. * @throws IOException if the API returns an error. */ public static void execute( AgenciesAndBrands agenciesAndBrandsClient, Long accountId, String reportId) throws IOException { String name = String.format("agencies/%s/reports/%s", accountId, reportId); System.out.printf("Running report with name \"%s\".%n", name); RunReportRequest requestBody = new RunReportRequest(); // Run the specified report to start an asynchronous operation. Operation operation = agenciesAndBrandsClient .agencies() .reports() .run(name, requestBody) .execute(); System.out.println("Successfully initiated report run operation:"); Utils.jsonPrettyPrint(operation); } /** * Creates and configures the ArgumentParser for this sample. * * @return the configured ArgumentParser. */ private static ArgumentParser createArgumentParser() { ArgumentParser parser = ArgumentParsers.newFor("RunReport") .build() .defaultHelp(true) .description("Runs a specified report asynchronously, returning an Operation " + "that can be used to track its progress."); // Required arguments. parser .addArgument("-a", "--account_id") .help("The account ID of the agency that created the report.") .required(true) .type(Long.class); parser .addArgument("-r", "--report_id") .help("The resource ID of the report to run.") .required(true); return parser; } public static void main(String[] args) { ArgumentParser parser = createArgumentParser(); Namespace parsedArgs = null; try { parsedArgs = parser.parseArgs(args); } catch (ArgumentParserException ex) { parser.handleError(ex); System.exit(1); } AgenciesAndBrands client = null; try { client = Utils.getAgenciesAndBrandsClient(); } catch (IOException ex) { System.out.printf("Unable to create Agencies & Brands API service:%n%s", ex); System.out.println("Did you specify a valid path to a service account key file?"); System.exit(1); } catch (GeneralSecurityException ex) { System.out.printf("Unable to establish secure HttpTransport:%n%s", ex); System.exit(1); } try { execute( client, parsedArgs.getLong("account_id"), parsedArgs.getString("report_id")); } catch (IOException ex) { System.out.printf("Agencies & Brands API returned error response:%n%s", ex); System.exit(1); } } }
Выполнение отчета — это асинхронная длительная операция. При вызове метода run API Agencies & Brands возвращает ресурс Operation . Поле name операции идентифицирует выполняемую операцию и имеет следующий формат:
agencies/ACCOUNT_ID/reports/REPORT_ID/operations/OPERATION_ID
Возвращаемый объект Operation содержит следующее:
-
name: имя, присвоенное сервером для длительной операции. REPORT_ID — уникальный идентификатор шаблона отчета, который вы запустили. OPERATION_ID — уникальный идентификатор, который Google присваивает операции, создаваемой при запуске шаблона отчета. -
metadata: необязательная информация о ходе выполнения, специфичная для данной услуги. Полеmetadataможет быть не заполнено в объектеOperation, который вы получаете в ответеagencies.reports.run.
После запуска отчета вы не сможете просмотреть его результаты, пока поле «Операция done » не примет true значение. Время выполнения отчета зависит от его сложности.
Следующие шаги
- Узнайте, как проводить опросы и просматривать готовые отчеты с помощью API агентств и брендов.
- Узнайте, как просматривать существующие отчеты с помощью API агентств и брендов.